/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef __BOOT_MGR_H__
#define __BOOT_MGR_H__
#include "addrspace.h"
#define BOOTFILE_MAX_SIZE (32<<20)
struct bootfile_ {
	char *name;
	unsigned long long start;
	int size;
	unsigned int max_size;
	int valid;
	int busy;
	int loaded;
};
struct boot_dev
{
	char name[20];
	unsigned long iobase;
	int (*saveboot)(struct boot_dev *this_boot, unsigned char *bootbuf,unsigned long nBytes);
	int (*readboot)(struct boot_dev *this_boot, unsigned char *bootbuf,unsigned long nBytes);
	int (*eraseboot)(struct boot_dev *this_boot,unsigned long nBytes);
	struct addr_space res;
	void *priv;
	struct boot_dev *next;
};

extern int register_bootdev(struct boot_dev *dev);
extern int register_backup_bootdev(struct boot_dev *dev);
extern int register_secondary_bootdev(struct boot_dev *dev);
extern int register_secondary_backup_bootdev(struct boot_dev *dev);
extern struct bootfile_ *get_bootfile();


#endif
