/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _IOMAP_H
#define _IOMAP_H

#include "types.h"

#define CPLD_BASE_ADDR                    0xffffffffBD840000ULL
#define DEFAULT_PHOENIX_IO_BASE 0xffffffffbef00000ULL
#define DEFAULT_XLP_IO_BASE 0xffffffffb8000000ULL

#define PHOENIX_IO_BRIDGE_OFFSET          0x00000

#define PHOENIX_IO_DDR2_CHN0_OFFSET       0x01000
#define PHOENIX_IO_DDR2_CHN1_OFFSET       0x02000
#define PHOENIX_IO_DDR2_CHN2_OFFSET       0x03000
#define PHOENIX_IO_DDR2_CHN3_OFFSET       0x04000

#define PHOENIX_IO_RLD2_CHN0_OFFSET       0x05000
#define PHOENIX_IO_RLD2_CHN1_OFFSET       0x06000

#define PHOENIX_IO_SRAM_OFFSET            0x07000

#define PHOENIX_IO_PCIX_OFFSET            0x09000
#define PHOENIX_IO_HT_OFFSET              0x0A000

#define PHOENIX_IO_SECURITY_OFFSET        0x0B000

#define PHOENIX_IO_GMAC_0_OFFSET          0x0C000
#define PHOENIX_IO_GMAC_1_OFFSET          0x0D000
#define PHOENIX_IO_GMAC_2_OFFSET          0x0E000
#define PHOENIX_IO_GMAC_3_OFFSET          0x0F000

#define PHOENIX_IO_SPI4_0_OFFSET          0x10000
#define PHOENIX_IO_XGMAC_0_OFFSET         0x11000
#define PHOENIX_IO_SPI4_1_OFFSET          0x12000
#define PHOENIX_IO_XGMAC_1_OFFSET         0x13000

#if defined(XLP_SIM)
#define PHOENIX_IO_PIC_OFFSET             0x04000
#define PHOENIX_IO_UART_0_OFFSET          0x30100
#define PHOENIX_IO_UART_1_OFFSET          0x31100
#define XLP_CMS_ADDR                      0xc0000000
#else
#define PHOENIX_IO_PIC_OFFSET             0x08000
#define PHOENIX_IO_UART_0_OFFSET          0x14000
#define PHOENIX_IO_UART_1_OFFSET          0x15000
#endif

#define PHOENIX_IO_I2C_0_OFFSET           0x16000
#define PHOENIX_IO_I2C_1_OFFSET           0x17000

#define PHOENIX_IO_GPIO_OFFSET            0x18000

#define PHOENIX_IO_FLASH_OFFSET           0x19000

#define PHOENIX_IO_DMA_OFFSET             0x1a000

#define PHOENIX_IO_TB_OFFSET              0x1c000

#define PHOENIX_IO_L2_OFFSET              0x1b000

#define PHOENIX_IO_GMAC_4_OFFSET          0x20000
#define PHOENIX_IO_GMAC_5_OFFSET          0x21000
#define PHOENIX_IO_GMAC_6_OFFSET          0x22000
#define PHOENIX_IO_GMAC_7_OFFSET          0x23000

#define PHOENIX_IO_PCIE_0_OFFSET          0x1E000
#define PHOENIX_IO_PCIE_1_OFFSET          0x1F000

#define PHOENIX_IO_USB_0_OFFSET           0x24000
#define PHOENIX_IO_USB_1_OFFSET           0x25000

#define PHOENIX_IO_COMP_OFFSET            0x1D000

#define PHOENIX_CPLD_OFFSET               0xffffffffbd840000ULL

#ifndef __ASSEMBLY__

#include "byteorder.h"

extern unsigned long phoenix_io_base;

#define phoenix_io_mmio(offset) ((phoenix_reg_t *)(phoenix_io_base+(offset)))

static inline uint32_t nlm_br_read_lock(void) 
{
	return 0;
}

static inline void nlm_br_read_unlock(unsigned int flags)
{
}

static inline uint32_t nlm_br_write_lock(void)
{
	return 0;
}

static inline void nlm_br_write_unlock(unsigned int flags)
{
}

#define phoenix_read_reg(base, offset) (be32_to_cpu((base)[(offset)]))
#define phoenix_write_reg(base, offset, value) ((base)[(offset)] = cpu_to_be32((value)))

#endif

#endif
