/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _SPILL_H
#define _SPILL_H

#include "net_config.h"
#include "device.h"

// spills for gmac0 (ports 0,1,2,3)
extern struct fr_desc     *gmac0_frin_spill;
extern struct fr_desc     *gmac0_frout_spill;
extern struct size_2_desc *gmac0_rx_spill0;
extern struct size_2_desc *gmac0_rx_spill1;
extern struct size_2_desc *gmac0_rx_spill2;
extern struct size_2_desc *gmac0_rx_spill3;

// spills for gmac1 (ports 4,5,6,7)
extern struct fr_desc     *gmac1_frin_spill;
extern struct fr_desc     *gmac1_frout_spill;
extern struct size_2_desc *gmac1_rx_spill0;
extern struct size_2_desc *gmac1_rx_spill1;
extern struct size_2_desc *gmac1_rx_spill2;
extern struct size_2_desc *gmac1_rx_spill3;

// spills for xgs0 (used by both xgmac & spi4)
extern struct fr_desc     *xgs0_frin_spill;
extern struct fr_desc     *xgs0_frout_spill;
extern struct size_2_desc *xgs0_rx_spill0;
extern struct size_2_desc *xgs0_rx_spill1;
extern struct size_2_desc *xgs0_rx_spill2;
extern struct size_2_desc *xgs0_rx_spill3;

// spills for xgs0 (used by both xgmac & spi4)
extern struct fr_desc     *xgs1_frin_spill;
extern struct fr_desc     *xgs1_frout_spill;
extern struct size_2_desc *xgs1_rx_spill0;
extern struct size_2_desc *xgs1_rx_spill1;
extern struct size_2_desc *xgs1_rx_spill2;
extern struct size_2_desc *xgs1_rx_spill3;

void spill_setup(struct net_config_struct *);
void nlm_config_spill(device_conf  * current_dev );


#endif
