/* Xen-specific pieces of head.S, intended to be included in the right
        place in head.S */

#include "elfnote.h"
// #include <linux/init.h>

#include "asm.h"
// #include "asmmacros.h"
// #include "asm-offsets.h"
// #include "addrspace.h"
// #include "page.h"
// #include <asm/pgtable-bits.h>

#include <xen/interface/elfnote.h>
#include <asm/xen/interface.h> /* present */
#include "xen/mm.h"		

#define __ASM_FORM(x)   x
# define __ASM_SEL(a,b) __ASM_FORM(a)

#define _ASM_PTR        __ASM_SEL(.long, .quad)

#ifndef __ALIGN
#define __ALIGN		.align 4,0x90
#define __ALIGN_STR	".align 4,0x90"
#endif
		
#define ASM_ALIGN __ALIGN
#define ASM_ALIGN_STR __ALIGN_STR
		
#ifndef ENTRY
#define ENTRY(name) \
  .globl name; \
  ASM_ALIGN; \
  name:
#endif

.pushsection .text
        .align XEN_PAGE_SHIFT
ENTRY(hypercall_page)
        .skip XEN_PAGE_SIZE
.popsection

		ELFNOTE(Xen, XEN_ELFNOTE_GUEST_OS,       .asciz "NetOS")
		ELFNOTE(Xen, XEN_ELFNOTE_GUEST_VERSION,  .asciz "2.6")
        ELFNOTE(Xen, XEN_ELFNOTE_XEN_VERSION,    .asciz "xen-3.0")
/*        ELFNOTE(Xen, XEN_ELFNOTE_VIRT_BASE,      _ASM_PTR PAGE_OFFSET) */
        ELFNOTE(Xen, XEN_ELFNOTE_HYPERCALL_PAGE, _ASM_PTR hypercall_page)
        ELFNOTE(Xen, XEN_ELFNOTE_LOADER,         .asciz "generic")
        ELFNOTE(Xen, XEN_ELFNOTE_SUSPEND_CANCEL, .long 1)
/*      ELFNOTE(Xen, XEN_ELFNOTE_HV_START_LOW,   _ASM_PTR __HYPERVISOR_VIRT_START) */
/*      ELFNOTE(Xen, XEN_ELFNOTE_PADDR_OFFSET,   _ASM_PTR 0) */
