/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/
#include "asm.h"
#include "stackframe.h"
#include "mipsregs.h"
	
	.text
	.set	mips4
	.align	5

NESTED(xlr_lib_entry_asm, K_STACK_SIZE, sp)
	.set	noat
	.set	noreorder

	move	sp, a0
	move 	gp, a1
	move	t9, a2
	move	a0, a3

	jr	t9
	nop

	.set	at
	.set	reorder
END(xlr_lib_entry_asm)

NESTED(call_start_func_asm, K_STACK_SIZE, sp)
	.set	noat
	.set	noreorder

	ld	t9, 32(sp)	/* func */
	ld	gp, 40(sp)	/* gp */
	ld	ra, 56(sp)	/* reentry_func */
	ld	sp, 48(sp)	/* sp */

	jr	t9
	nop

	.set	at
	.set	reorder
END(call_start_func_asm)
