#include <stdio.h>
#include <stdlib.h>

#include <shell.h>
#include <boot2.h>

#include "mips-exts.h"

extern char app_mode[];
extern char app_loadaddr[];
extern void userapp_os_run(int argc, char *argv[]);

int dom_id;
extern int dom_destroy_hack;

int main(int argc, char *argv[])
{
	printf(" \n\n");
	printf(" ========================= \n");
	printf("| 	  Starting NetOS      |\n");
	printf(" ========================= \n");
	printf(" \n");

	shell_init();

	/* Main initialization call
	 * for the loader
	 */
	userapp_init();

	xlr_launch_init();

	shell_help(0, NULL);

	/*
	 * XXX Fixme 
	 * Currently, the app is not run - this is done to avoid
	 * the app stepping on the trap handlers setup by netOS in order to support
	 * destroy_domain functionality of xen.
	 */
	if (dom_destroy_hack)
		printf("dom_destroy_hack is set, disabling auto-boot\n");

	if (!dom_destroy_hack && app_mode[0] && app_loadaddr[0]) {

		char *app_argv[] = {
			[1] = "-a",
			[3] = ""
		};
		int app_argc = 3;

		app_argv[0] = app_mode;
		app_argv[2] = app_loadaddr;

		printf("Autobooting application...\n");
		userapp_os_run(app_argc, app_argv);
	}

	/* Drop in to a shell */
	shell_app_init();

	while (1) {
		shell_run();
	}

	return 0;
}
